
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/datatypes.h>
#include <datatypes/pictureclass.h>

int main (void)

{
struct RDArgs *rdargs;
static struct {
	char *file;
	char *pubscreen;
	} args = {NULL};
int rc = RETURN_ERROR;
Object *o;
struct BitMapHeader *bmhd;
struct BitMap *bm;
long w,h,d,i,x,y,bpr;
UWORD *xp,*yp;

if (rdargs = ReadArgs ("FILE/A",(APTR)&args,NULL))
	{

	if (o = NewDTObject (args.file,
			DTA_GroupID,GID_PICTURE,
			PDTA_Remap,FALSE,
			TAG_END))

		{
		DoDTMethod (o,NULL,NULL,DTM_PROCLAYOUT,NULL,TRUE);

		GetDTAttrs (o,
			PDTA_BitMapHeader,&bmhd,
			PDTA_DestBitMap,&bm,
			TAG_END);

		d = GetBitMapAttr(bm,BMA_DEPTH);
		if (d > 8)
			Printf ("bitmap depths greater than 8 are not supported\n");
		else
			{
			w = (bmhd->bmh_Width + 15) >> 4;
			h = bmhd->bmh_Height;
			bpr = bm->BytesPerRow >> 1;
			for (i = 0; i < d; i++)
				{
				yp = (UWORD *)bm->Planes[i];
				Printf ("	__chip UWORD bitplane%ld[] = {\n",i+1);
				for (y = 0; y < h; y ++)
					{
					xp = yp;
					Printf ("		");
					for (x = 0; x < w; x++)
						Printf ("0x%04lx,",*xp++);
					Printf ("\n");
					yp += bpr;
					}
				Printf ("		};\n\n");
				}
			Printf ("	struct BitMap bitmap = {\n		%ld,%ld,0,%ld,0,\n		",w<<1,h,d);
			for (i = 1; i < d; i++)
				Printf ("(PLANEPTR)bitplane%ld,",i);
			Printf ("(PLANEPTR)bitplane%ld\n		};\n\n",i);

			Printf ("	#define BMWIDTH  %4ld\n	#define BMHEIGHT %4ld\n",bmhd->bmh_Width,bmhd->bmh_Height);

			rc = RETURN_OK;
			}

		DisposeDTObject (o);
		}

	FreeArgs (rdargs);
	}

PrintFault (IoErr(),NULL);
return (rc);
}

